Non-default identifier-less git repositories are undeletable

2015-03-03 18:16 - Felix Schäfer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version: 2.6.3   

Resolution: Fixed Affected version: 2.5.2

Description

Git repositories without an identifier that are not default (because another repository in the project has been promoted as default) are

not deletable. This was tested on 2.3 and 2.5, but the code seems to still be in use in current trunk.

This is due to http://www.redmine.org/projects/redmine/repository/entry/branches/2.6-stable/app/models/repository.rb#L41 preventing

successful saving in http://www.redmine.org/projects/redmine/repository/entry/branches/2.6-stable/app/models/repository/git.rb#L254

and makes the before_destroy in repository.rb fail.

I'm not quite sure what the intent of the validation was, I guess to enforce that if there is a repository with no identifier it is the default,

but it seems possible to work around that after the creation of the identifier-less repository.

Attached is a patch with a failing test, the test passes with the validation removed, and removing the validation causes no other tests

to fail.

Associated revisions

Revision 14050 - 2015-03-07 17:02 - Jean-Philippe Lang

Fixed that non-default identifier-less git repositories are undeletable (#19260).

Patch by Felix Schäfer.

Revision 14058 - 2015-03-08 10:42 - Jean-Philippe Lang

Merged r14050 (#19260).

Revision 14059 - 2015-03-08 10:42 - Jean-Philippe Lang

Merged r14050 (#19260).

History

#1 - 2015-03-04 04:45 - Toshi MARUYAMA

- Target version set to 2.6.3

#2 - 2015-03-07 17:03 - Jean-Philippe Lang

- Subject changed from non-default identifier-less git repositories are undeletable to Non-default identifier-less git repositories are undeletable

- Description updated

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patch applied in r14050, thanks.

#3 - 2015-03-08 10:42 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

#4 - 2015-03-17 00:37 - Nicolas Rodriguez
http://www.redmine.org/projects/redmine/repository/entry/branches/2.6-stable/app/models/repository.rb#L41
http://www.redmine.org/projects/redmine/repository/entry/branches/2.6-stable/app/models/repository/git.rb#L254
https://www.redmine.org/projects/redmine/repository/svn/revisions/14050


Hi!

This patch introduces the possibility of having 2 (or more) repositories with empty identifier.

Is this something intendend?

Maybe a self.save(validate: false) in clear_extra_info_of_changesets would have done the job too? (specially if the repository is about to be deleted)

Thanks,

Nicolas

#5 - 2015-03-17 00:51 - Toshi MARUYAMA

Nicolas Rodriguez wrote:

Hi!

This patch introduces the possibility of having 2 (or more) repositories with empty identifier.

Is this something intendend?

Maybe a self.save(validate: false) in clear_extra_info_of_changesets would have done the job too? (specially if the repository is about to be

deleted)

Thanks,

Nicolas

 I have created #19400, because 2.6.3 was released.

#6 - 2015-03-17 01:15 - Nicolas Rodriguez

- File Configuration - test - Redmine.png added

#7 - 2015-03-17 01:23 - Toshi MARUYAMA

- File deleted (Configuration - test - Redmine.png)

Files

repo_identifiers.diff 2.09 KB 2015-03-03 Felix Schäfer
